-----------------------------------------------------------------------------------------------
-- Client Lua Script for InvAccept
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------

require "Window"
require "GroupLib"

 
-----------------------------------------------------------------------------------------------
-- InvAccept Module Definition
-----------------------------------------------------------------------------------------------
local InvAccept = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function InvAccept:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function InvAccept:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureButton, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- InvAccept OnLoad
-----------------------------------------------------------------------------------------------
function InvAccept:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("InvAccept.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	Apollo.RegisterEventHandler("Group_Invited","OnGroupInvited", self)
end

-----------------------------------------------------------------------------------------------
-- InvAccept OnDocLoaded
-----------------------------------------------------------------------------------------------
function InvAccept:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "InvAcceptForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- InvAccept Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function InvAccept:OnGroupInvited(strInviterName)
self.wndMain:Show(true, true)
self.wndMain:FindChild("Title"):SetText("Invite from "..strInviterName)
self.wndMain:ToFront()
--print("Invite accepted by"..strInviterName)
end
-----------------------------------------------------------------------------------------------
-- InvAcceptForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function InvAccept:OnOK()
	self.wndMain:Show(false) -- hide the window
	GroupLib.AcceptInvite()
end

-- when the Cancel button is clicked
function InvAccept:OnCancel()
	self.wndMain:Show(false)
	GroupLib.DeclineInvite() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- InvAccept Instance
-----------------------------------------------------------------------------------------------
local InvAcceptInst = InvAccept:new()
InvAcceptInst:Init()
